package com.prolog.eis.service.shelves;


import com.prolog.eis.dto.page.AllotmentTaskRecordReqDto;
import com.prolog.eis.dto.page.AllotmentTaskRecordResultDto;
import com.prolog.eis.model.shelves.AllotmentCfg;
import com.prolog.framework.core.restriction.Criteria;

import java.util.List;
import java.util.Map;

/**
 * @author zmr
 * @description: 分拨站配置表-服务接口类
 * @date 2023-08-28 11:41
 */
public interface AllotmentCfgService {

    /**
     * 新增数据
     *
     * @param allotmentCfg 分拨站配置表
     */
    long save(AllotmentCfg allotmentCfg);

    /**
     * 新增批量数据
     *
     * @param allotmentCfgList 分拨站配置表
     */
    long saveBatch(List<AllotmentCfg> allotmentCfgList);

    /**
     * 查询多条数据
     *
     * @param paramMap 查询起始位置
     * @return 对象列表
     */
    List<AllotmentCfg> findByMap(Map<String, Object> paramMap);

    /**
     * 查询单条数据
     *
     * @param paramMap 查询起始位置
     * @return 对象
     */
    AllotmentCfg findOneByMap(Map<String, Object> paramMap);

    /**
     * 查询多条数据
     *
     * @param criteria 查询起始位置
     * @return 对象列表
     */
    List<AllotmentCfg> findByCriteria(Criteria criteria);

    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
    AllotmentCfg findById(int id);

    /**
     * 修改数据
     *
     * @param allotmentCfg 实例对象
     */
    long update(AllotmentCfg allotmentCfg);

    /**
     * 通过主键删除数据
     *
     * @param id 主键
     */
    long deleteById(int id);

    /**
     * 通过参数删除数据
     *
     * @param paramMap 参数
     */
    long deleteByMap(Map<String, Object> paramMap);

    /**
     * 通过参数查询总条数
     *
     * @param paramMap 参数
     */
    long findCountByMap(Map<String, Object> paramMap);

    List<AllotmentTaskRecordResultDto> allotmentTaskRecordList(AllotmentTaskRecordReqDto req);
}
